--------------------------------------------------------------------------------
-- Company: 
-- Engineer:
--
-- Create Date:    00:28:38 01/14/06
-- Design Name:    
-- Module Name:    main - Verhalten
-- Project Name:   PWM_OUT
-- Target Device:  
-- Tool versions:  
-- Description:
--
-- Dependencies:
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
-- 
--------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity main is
	 generic (
	 				frequenz_faktor : integer := 50000 -- Entspricht 1kHz	

	 			 );
    Port ( 
    			clk : in std_logic;
          rst : in std_logic;
          
         	Dip1	: in std_logic;
         	Dip2	: in std_logic;
         	Dip3	: in std_logic;
         	Dip4	: in std_logic;
           	
         	Led1 : out std_logic;
         	Led2 : out std_logic;
         	Led3 : out std_logic;
         	Led4 : out std_logic;
         	
         	Pin45 : out std_logic
         );
end main;

architecture Verhalten of main is

begin

	frequenz_takt_proc:process (clk,rst)
	
	variable frequenz_count		: integer range 0 to frequenz_faktor;
	variable pulsdauer				: integer;
	variable dip_int					: integer;

	
	begin
	Led2 <= '1';
	Led3 <= '1';
	
		if rst = '0' or pulsdauer > 100 then
			frequenz_count := 0;
			Pin45 <= '0';
			Led1 <= '1';
			Led4 <= '0';
		else
			Led4 <= '1';				
				if falling_edge(clk) then
				
				if Dip1 = '0' then
					dip_int := 1 ;
				else
					dip_int := 0;
				end if;
				
				if Dip2 = '0' then
					dip_int := dip_int + 2;
				end if;
				
				if Dip3 = '0' then
					dip_int := dip_int + 4;
				end if;
			
			--  Wenn ich diesen Dip4 auskommentiere funktioniert's ohn e Probleme	
				if Dip4 = '0' then
					dip_int := dip_int + 8;
			  end if;
				
			pulsdauer := 6 * dip_int;
					
			-- Frequenzgenerator
				if frequenz_count < frequenz_faktor then
					frequenz_count := frequenz_count + 1;
					if frequenz_count < ((frequenz_faktor /100 )* pulsdauer) then
						Led1 <= '0';
						Pin45 <= '1';
					else
						Led1 <= '1';
						Pin45 <= '0';
					end if;
				else
					frequenz_count := 0;
				end if;
			end if;
		end if;
	end process;

end Verhalten;